%%
simulation.TiBr      = 0.5;             % [s]  
simulation.DT        = 1e-5;            % [s]  
simulation.initPos   = 0;               % [rad]         posizione iniziale (albero lento)
simulation.timeCom   = [0 0.1 0.1+simulation.DT simulation.TiBr];   % parametri comando 'Com'
simulation.com       = [0 0 0.1 0.1];
simulation.tauFilter = 5*10e-5;         % [s]  

%%
controller.Gprop    = 1e5;              % [1/s]   
controller.W_refMax = 8000*pi/30;       % [rad/s]  
controller.PID.GAP  = 0.05;             % [Nms/rad] 
controller.PID.ErIM = 100;              % [Nm]        
controller.I_Max    = 22.5;             % [A]           saturazione I_ref
controller.Knoise   = 0;                % []            coefficiente moltiplicativo Rumore (0 - 1 - 10 - 100)
controller.PID.band = 1e-3;             % [rad]         tolleranza ramo integrativo
controller.PID.Ti   = 10000;            % [s]           tempo caratteristico ramo integrativo
controller.PID.Tt   = 1;                % [s]           tempo caratteristico compensazione windup
controller.PID.Td   = 0;                % [s]           tempo caratteristico ramo derivativo
controller.PID.N    = 1000;             % [1/s]         banda passante filtro derivativo
GP=1e5;
controller.GAPm1     = 1e5;             % [1/s]         guadagno proporzionale controller                       == controller.Gprop
controller.GAPm2     = 0.05;            % [Nms/rad]     guadagno proporzionale PID                              == controller.PID.GAP
controller.W_refMax  = 8000*pi/30;      % [rad/s]       saturazione errore posizione

%%
inverter.PWM.hb           = 0.5;        % [A]           ampiezza banda di isteresi
inverter.Hbridge.Vdc      = 48;         % [V]           tensione alimentazione
inverter.Hbridge.RSnubber = 1e5;        % [ohm]         resistenza snubber
inverter.Hbridge.CSnubber = inf;        % [F]           capacità snubber
inverter.Hbridge.Ron      = 1e-2;       % [ohm]         Ron (in Universal Bridge)


%%
BLDC.P    = 2;                          % []            numero paia poli
BLDC.Nabc = [1 1 1];                    % []            frazione spire attive (fasi A, B, C)
BLDC.Ke   = 0.0752/2;                   % [Nm/A]        costante di fcem del motore  
BLDC.Rs   = 2.130;                      % [ohm]         resistenza nominale fase-fase (es. Rab)
BLDC.Ls   = 720*1e-6 ;                  % [H]           induttanza nominale fase-fase (es. Lab)
BLDC.tauRLs=BLDC.Ls/BLDC.Rs;       	% Costante di tempo RL del DC Motor                                     [s]
BLDC.TMM  = 1.689;                      % [Nm]          saturazione coppia
BLDC.zeta = 0;                          % []            modulo eccentricità statica
BLDC.phi  = 0; 

electrical.P         = 2;               % []            numero paia poli                                        == BLDC.P
electrical.Z         = 0;               % []            modulo eccentricità                                     == 0.42 * BLDC.zeta
electrical.phi       = 0;               % [rad]         fase eccentricità                                       == BLDC.phi
electrical.Vdcm      = 48;              % [V]  
electrical.TMM       = 1.689;           % [Nm]          saturazione coppia motore                               == BLDC.TMM
electrical.Nabc      = [1 1 1];         % []            frazione spire attive                                   == BLDC.N_abc
electrical.Kv        = 0.0752;          % [Nm/A]        valore nominale                                         == 2 * BLDC.Ke
electrical.Ke        = 0.0752;%0.07648;         % [Nm/A]        costante forza controelettromotrice                     (valore calibrato)
electrical.Rm        = 2.130;           % [ohm]         resistenza motore                                       == BLDC.Rs
electrical.Lm        = 720*1e-6;        % [H]           induttanza motore                                       == BLDC.Ls
electrical.tauRLm=electrical.Lm/electrical.Rm;
electrical.GT        = 0.0752;%0.07322;         % [Nm/A]        guadagno in coppia                                      (valore calibrato)
electrical.Nabc      = [1 1 1]; 
%%
dynamics.tau = 1/500; 
dynamics.BLK = 1e-5; 
%BLKal=1e-5;
%BLK=BLKal/tau;
dynamics.ThUmin        = -1;            % [rad]         finecorsa inferiore
dynamics.ThUmax        = 1;             % [rad]         finecorsa superiore

dynamics.friction.FSTm = 0.06;          % []            attrito statico  motore       (albero veloce - espresso in percentuale di BLDC.TMM)
dynamics.friction.FDTm = 0.03;          % []            attrito dinamico motore       (albero veloce - espresso in percentuale di BLDC.TMM)
dynamics.friction.FSTu = 0.04;          % []            attrito statico  utilizzatore (albero veloce - espresso in percentuale di BLDC.TMM)
dynamics.friction.FDTu = 0.02;          % []            attrito dinamico utilizzatore (albero veloce - espresso in percentuale di BLDC.TMM)

%     FSM=dynamics.friction.FSTm;
%     FSU=dynamics.friction.FSTu;
%     FDM=FSM/2;
%     FDU=FSU/2;
% % FST=(FSM+FSU);          	% Coefficiente Attrito Statico Utilizzatore Finale                    	[N*m]
% % FDT=(FDM+FDU);         	% Coefficiente Attrito Dinamico Utilizzatore Finale                 	[N*m]

% %         FrictIN=linspace(ThUmin,ThUmax,100);
% %         FrictOUT=ones(1,100);

dynamics.JM            = 130e-007;       % [kg*m^2]      Momento d'inerzia del DC Motor (AV=albero veloce)
dynamics.CM            = 30/pi*1e-6;    % [N*m*s/rad]   Coefficiente di smorzamento viscoso dimensionale DC Motor (AV)
dynamics.JU            = 12e-6;         % [kg*m^2]      Momento d'inerzia utilizzatore ridotto all'albero veloce
dynamics.CU            = 4.5070e-7;     % [N*m*s/rad]   Coefficiente di smorzamento viscoso dimensionale utilizz.(AV)

mechanical.Jm        = 2.5e-5;          % momento di inerzia totale                                             == dynamics.JM+dynamics.JU
mechanical.Cm        = 5.172e-5;        % coefficiente attrito viscoso                                          (valore calibrato)

BLK=1e-5;
mechanical.BLK       = 1e-5;            % [rad]         backlash width (albero lento)                           == dynamics.BLK
mechanical.tau       = 1/500;           % []            rapporto di trasmissione                                == dynamics.tau

mechanical.FSTm = 0.06;          % []            attrito statico  motore       (albero veloce - espresso in percentuale di BLDC.TMM)
mechanical.FDTm = 0.03;          % []            attrito dinamico motore       (albero veloce - espresso in percentuale di BLDC.TMM)
mechanical.FSTu = 0.04;          % []            attrito statico  utilizzatore (albero veloce - espresso in percentuale di BLDC.TMM)
mechanical.FDTu = 0.02;          % []            attrito dinamico utilizzatore (albero veloce - espresso in percentuale di BLDC.TMM)

mechanical.FST       = 0.1;             % []            attrito statico (AV - percentuale di electrical.TMM)    == dynamics.friction.FSTm + dynamics.friction.FSTu
mechanical.FDT       = 0.05;            % []            attrito dinamico (AV - percentuale di electrical.TMM)   == dynamics.friction.FDTm + dynamics.friction.FDTu

mechanical.ThUmin    = -1;              % [rad]         finecorsa inferiore                                     == dynamics.ThUmin
mechanical.ThUmax    = 1;               % [rad]         finecorsa superiore                                     == dynamics.ThUmax


