%%
simulation.TiBr      = 0.5;             % [s]  
simulation.DT        = 1e-6;            % [s]  
simulation.initPos   = 0;               % [rad]         posizione iniziale (albero lento)
simulation.timeCom   = [0 0.1 0.1+simulation.DT simulation.TiBr];   % parametri comando 'Com'
simulation.com       = [0 0 0.1 0.1];
simulation.tauFilter = 5*10e-5;         % [s]  

%%
inverter.Hbridge.Vdc      = 48;         % [V]           tensione alimentazione
inverter.PWM.hb           = 0.5;        % [A]           ampiezza banda di isteresi
inverter.Hbridge.RSnubber = 1e5;        % [ohm]         resistenza snubber
inverter.Hbridge.CSnubber = inf;        % [F]           capacità snubber
inverter.Hbridge.Ron      = 1e-2;       % [ohm]         Ron (in Universal Bridge)

%%
controller.PID.GAP  = 0.05;             % [Nms/rad] 
controller.PID.ErIM = 100;              % [Nm]   
controller.I_Max    = 22.5;             % [A]           saturazione I_ref
controller.Knoise   = 0;                % []            coefficiente moltiplicativo Rumore (0 - 1 - 10 - 100)
controller.W_refMax = 8000*pi/30;       % [rad/s]  
controller.PID.GAP  = 0.05;             % [Nms/rad] 
controller.GAPm1     = 1e5;             % [1/s]         guadagno proporzionale controller                       == controller.Gprop
controller.GAPm2     = 0.05;            % [Nms/rad]     guadagno proporzionale PID                              == controller.PID.GAP
controller.PID.band = 1e-3;             % [rad]         tolleranza ramo integrativo
controller.PID.Ti   = 10000;            % [s]           tempo caratteristico ramo integrativo
controller.PID.Tt   = 1;                % [s]           tempo caratteristico compensazione windup
controller.PID.Td   = 0;                % [s]           tempo caratteristico ramo derivativo
controller.PID.N    = 1000;             % [1/s]         banda passante filtro derivativo
controller.Gprop    = G*1e5;            % [1/s]         guadagno proporzionale controller     % 5e2/tau

%%
BLDC.Ke   = 0.0752/2;                   % [Nm/A]        costante di fcem del motore  
BLDC.Rs   = 2.130;                      % [ohm]         resistenza nominale fase-fase (es. Rab)
BLDC.Ls   = 720*1e-6 ;                  % [H]           induttanza nominale fase-fase (es. Lab)
BLDC.tauRLs=BLDC.Ls/BLDC.Rs;       	% Costante di tempo RL del DC Motor                                     [s]
% BLDC.Nabc = [1 1 1];                    % []            frazione spire attive (fasi A, B, C)
BLDC.P    = 2;                          % []            numero paia poli
BLDC.TMM  = 1.689;                      % [Nm]          saturazione coppia
% BLDC.zeta = 0;                          % []            modulo eccentricità statica
% BLDC.phi  = 0;                          % []            fase eccentricità statica

electrical.Kv        = 0.0752;          % [Nm/A]        valore nominale                                         == 2 * BLDC.Ke
electrical.Ke        = 0.0752;%0.07648;         % [Nm/A]        costante forza controelettromotrice                     (valore calibrato)
electrical.P         = 2;               % []            numero paia poli                                        == BLDC.P
electrical.TMM       = 1.689;           % [Nm]          saturazione coppia motore                               == BLDC.TMM
electrical.Vdcm      = 48;              % [V]  
electrical.Rm        = 2.130;           % [ohm]         resistenza motore                                       == BLDC.Rs
electrical.Lm        = 720*1e-6;        % [H]           induttanza motore                                       == BLDC.Ls
electrical.tauRLm=electrical.Lm/electrical.Rm;
electrical.Nabc      = [1 1 1]; 
%%
dynamics.tau = 1/500; 
dynamics.BLK = B*1e-5; 
        
dynamics.ThUmin        = -1;            % [rad]         finecorsa inferiore
dynamics.ThUmax        = 1;             % [rad]         finecorsa superiore
dynamics.friction.FSTm = 0.06*F;          % []            attrito statico  motore       (albero veloce - espresso in percentuale di BLDC.TMM)
dynamics.friction.FDTm = 0.03*F;          % []            attrito dinamico motore       (albero veloce - espresso in percentuale di BLDC.TMM)
dynamics.friction.FSTu = 0.04*F;          % []            attrito statico  utilizzatore (albero veloce - espresso in percentuale di BLDC.TMM)
dynamics.friction.FDTu = 0.02*F;          % []            attrito dinamico utilizzatore (albero veloce - espresso in percentuale di BLDC.TMM)
dynamics.JM            = 130e-007;       % [kg*m^2]      Momento d'inerzia del DC Motor (AV=albero veloce)
dynamics.CM            = 30/pi*1e-6;    % [N*m*s/rad]   Coefficiente di smorzamento viscoso dimensionale DC Motor (AV)
dynamics.JU            = 12e-6;         % [kg*m^2]      Momento d'inerzia utilizzatore ridotto all'albero veloce
dynamics.CU            = 4.5070e-7;     % [N*m*s/rad]   Coefficiente di smorzamento viscoso dimensionale utilizz.(AV)

mechanical.Jm        = 2.5e-5;          % momento di inerzia totale                                             == dynamics.JM+dynamics.JU
mechanical.Cm        = 5.172e-5;        % coefficiente attrito viscoso                                          (valore calibrato)

     
