function [err]=FitnessFunction(k)
run('DatiCompleti')
flag=1;

%% Ottimizzazione


    load('HF.mat')
    load('errorcurrent.mat')


% attrito

    F=interp1([0 1],[1 3],k(1));
    mechanical.FST=F*(mechanical.FSTm+mechanical.FSTu);
    mechanical.FDT=F*(mechanical.FDTm+mechanical.FDTu);    
    
    % backlash

    B=interp1([0 1],[1 100],k(2));   
    mechanical.BLK=dynamics.BLK*B;

% CC spire

    electrical.Nabc(1)=interp1([0 1],[1 0],k(3));
    electrical.Nabc(2)=interp1([0 1],[1 0],k(4));
    electrical.Nabc(3)=interp1([0 1],[1 0],k(5));

    if electrical.Nabc(1)==0, electrical.Nabc(1)=1e-2; end % per evitare che il calcolo esploda con 2 fasi completamente in CC
    if electrical.Nabc(2)==0, electrical.Nabc(2)=1e-2; end
    if electrical.Nabc(3)==0, electrical.Nabc(3)=1e-2; end    
    
    %electrical.tauRLm=electrical.tauRLm*(electrical.Nabc(1)+electrical.Nabc(2)+electrical.Nabc(3))/3;
    
% eccentricit rotore

	electrical.Z=interp1([0 1],[0 1],k(6));
    electrical.phi=interp1([0 1],[-pi pi],k(7));
% guadagno proporzionale
    
    %controller.GAPm1=interp1([0 1],[0.5 1.5],k(8));
    controller.GAPm1=interp1([0 1],[0.5*controller.GAPm1 1.5*controller.GAPm1],k(8));


% simulazione modello semplificato
try
    options = simset('SrcWorkspace','current');
    sim('Monitor',[],options);

catch 
    flag=0;
    
end

if flag==0
    err=10000;
else

% calcolo errore corrente

    y1=HF(2,:);
    y2=iLF'+errorcurrent;
    
    RMSE= sqrt(mean((y1 - y2).^2));
    dy=gradient(y1)/RMSE/simulation.DT;
        
    err=sum((y1-y2).^2./(dy.^2+1))*simulation.DT;   % 10*DT  il sampling time, equivale a dividere per il numero di punti
    
end
end
