delete(gcp('nocreate'))
clear all
clc

%% Optimization choice

OptChoice=input('Would you like to study a single-faulty or a multiple-faulty BLDC motor? (1=single, 2=multiple): ');
disp(' ');

if OptChoice==1

    %% Fault choice

    disp(' ')
    disp('Choose the fault you would like to introduce:')
    disp('1= Friction fault')
    disp('2= Backlash fault ')
    disp('3= Phase A short circuit fault')
    disp('4= Phase B short circuit fault')
    disp('5= Phase C short circuit fault')
    disp('6= Eccentricity parameter fault (zita) ')
    disp('7= Eccentricity phase fault ')
    disp('8= Gain fault ')
    disp(' ')

    b=input('Your choice: ');
    
    %Imposto i parametri e faccio girare il file dati con guasto

    if b==1
        F=input('Give a value for the friction [1 - 3] --> [NC - 3*NC]: ');         %Parametro moltiplicativo per l'attrito
        B=1;                                                                        %Parametro moltiplicativo per il backlash
        BLDC.zeta=0;                                                                        %Parametro dipendente dall'entità del guasto per eccentricità
        BLDC.Nabc=[1 1 1];
        BLDC.phi=0;                                                                      %Sfasamento dell'eccentricità del rotore
        G=1;                                                                        %Parametro moltiplicativo per il gain

        if F<1 || F>3
            disp('Do a valid choice!')
            clear
        else    
            run('DatiGuasti')
        end
    elseif b==2
        F=1;
        B=input('Give a value for the backlash [1 - 100] --> [NC - 100*NC]: ');
        BLDC.zeta=0;                                                                        %Parametro dipendente dall'entità del guasto per eccentricità
        BLDC.Nabc=[1 1 1];
        BLDC.phi=0; 
        G=1;

        if B<1 || B>100
            disp('Do a valid choice!')
            clear
        else    
            run('DatiGuasti')
        end
    elseif b==3
        F=1;
        B=1;
        BLDC.Nabc(1)=input('Give a value for the phase A short-circuit [1 - 0] --> [0% - 100%]: ');
        BLDC.Nabc(2)=1;
        BLDC.Nabc(3)=1;
        BLDC.zeta=0;                                                                        %Parametro dipendente dall'entità del guasto per eccentricità
        BLDC.phi=0; 
        G=1;

        if BLDC.Nabc(1)<0 || BLDC.Nabc(1)>1
            disp('Do a valid choice!')
            clear
        else    
            run('DatiGuasti')
        end
    elseif b==4
        F=1;
        B=1;
        BLDC.Nabc(1)=1;
        BLDC.Nabc(2)=input('Give a value for the phase B short-circuit [1 - 0] --> [0% - 100%]: ');
        BLDC.Nabc(3)=1;
        BLDC.zeta=0;                                                                        %Parametro dipendente dall'entità del guasto per eccentricità
        BLDC.phi=0; 
        G=1;

        if BLDC.Nabc(2)<0 || BLDC.Nabc(2)>1
            disp('Do a valid choice!')
            clear
        else    
            run('DatiGuasti')
        end
    elseif b==5
        F=1;
        B=1;
        BLDC.Nabc(1)=1;
        BLDC.Nabc(3)=input('Give a value for the phase B short-circuit [1 - 0] --> [0% - 100%]: ');;
        BLDC.Nabc(2)=1;
        BLDC.zeta=0;                                                                        %Parametro dipendente dall'entità del guasto per eccentricità
        BLDC.phi=0; 
        G=1;

        if BLDC.Nabc(3)<0 || BLDC.Nabc(3)>1
            disp('Do a valid choice!')
            clear
        else    
            run('DatiGuasti')
        end
    elseif b==6
        F=1;
        B=1;
        BLDC.Nabc(1)=1;
        BLDC.Nabc(2)=1;
        BLDC.Nabc(3)=1;
        BLDC.zeta=input('Give a value for the Z [0 - 1]: ');
        BLDC.phi=0;
        G=1;

        if BLDC.zeta<0 || BLDC.zeta>1
            disp('Do a valid choice!')
            clear
        else    
            run('DatiGuasti')
        end
    elseif b==7
        F=1;
        B=1;
        BLDC.Nabc(1)=1;
        BLDC.Nabc(2)=1;
        BLDC.Nabc(3)=1;
        BLDC.zeta=0;
        BLDC.phi=input('Give a value for the eccentricity phase [-pi - +pi]: ');
        G=1;

        if BLDC.phi<-pi || BLDC.phi>pi
            disp('Do a valid choice!')
            clear
        else    
            run('DatiGuasti')
        end
    elseif b==8
        F=1;
        B=1;
        BLDC.Nabc(1)=1;
        BLDC.Nabc(2)=1;
        BLDC.Nabc(3)=1;
        BLDC.zeta=0;
        BLDC.phi=0;
        G=input('Give a value for the gain [0.5 - 1.5] --> [0.5*NC - 1.5*NC]: ');

        if G<0.5 || G>1.5
            disp('Do a valid choice!')
            clear
        else    
            run('DatiGuasti')
        end
    else 
        disp('Do a valid choice!')
        clear
    end

    % Termina la parte del guasto singolo

    elseif OptChoice==2		%% Inizia guasto multiplo
    InputType=input('Would you like to introduce a random multiple fault (choose 1) or write the fault parameters by your own (choose 2)?: ');

    if InputType==1         %% Guasto multiplo random
		
		RandomFaultParams=rand(1,8);
        RandomFaultParams(:,1:6)=RandomFaultParams(:,1:6).^7;
        RandomFaultParams(:,8)=((RandomFaultParams(:,8)*2-1).^7+1)/2;
		disp(' ')
		disp(['The random fault vector is: ',mat2str(RandomFaultParams(:))])
        save('Random_fault', 'RandomFaultParams')
		disp(' ')
        
		F=2*(RandomFaultParams(1,1))+1;
		B=99*(RandomFaultParams(1,2))+1;
		BLDC.Nabc(1)=1-RandomFaultParams(1,3);
		BLDC.Nabc(2)=1-RandomFaultParams(1,4);
		BLDC.Nabc(3)=1-RandomFaultParams(1,5);
		BLDC.zeta=0.42*(RandomFaultParams(1,6));
		BLDC.phi=RandomFaultParams(1,7);
		G=RandomFaultParams(1,8)+0.5;
        
        run('DatiGuasti');
        
    elseif InputType==2     %% Guasto multiplo introdotto
        
        disp(' ');
        F=2*input('Introduce the friction fault: ')+1;
		B=99*input('Introduce the backlash fault: ')+1;
		BLDC.Nabc(1)=1-input('Introduce the phase A short-circuit fault: ');
		BLDC.Nabc(2)=1-input('Introduce the phase B short-circuit fault: ');
		BLDC.Nabc(3)=1-input('Introduce the phase C short-circuit fault: ');
		BLDC.zeta=0.42*input('Introduce the eccentricity fault: ');
		BLDC.phi=input('Introduce the eccentricity phase fault: ');
		G=input('Introduce the gain fault: ')+0.5;
        
        run('DatiGuasti');
        
    else
        disp('Do a valid choice!')
        clear       
    end        
    
                  
end                     %Termina la scelta del guasto
    
    
    
    
%% Simulation of the reference Model

sim('Reference');              % This simulation creates HF.mat (current file)

disp(' ')
disp('Choose the optimization algorithm: ')
disp('1= Genetic Algorithm')
disp('2= Particle Swarm Optimization')
disp('3= Differential Evolution')
disp('4= Greywolf Optimization')
disp(' ')
c=input('Your choice: ');
disp(' ')
d=input('Would you like to parallelize the optimization? (1=yes, 2=no)');

%Parallelization of the optimizations

if d==1
    parpool
    Parp=true(1);
else
    Parp=false(1);
end

%Choose the optimization features


% For every set of input, I do 10 optimizations (heuristic!=deterministic)
numOpt=input('How many optimizations do you like to do?');

X=zeros(numOpt,8);
Y=zeros(numOpt,8);
LB=zeros(1,8);
UB=ones(1,8);
disp(' ') 

for i=1:numOpt
    
    if c==1	
        popsize=input('Specify the population size: ');
        numgen=input('Specify the number of generations: ');
        tic
        opt1=optimoptions(@ga,'Display','iter','PopulationSize',popsize,'Generations',numgen,'FunctionTolerance',1e-12, 'UseParallel',Parp);
        X(i,:)=ga(@FitnessFunction,8,[],[],[],[],LB,UB,[],[],opt1);
        toc
        save('Results_GA','X')
        
    elseif c==2
        popsize=input('Specify the population size: ');
        tic
        opt2=optimoptions(@particleswarm,'Display','iter','SwarmSize',popsize,'MaxIterations',150,'FunctionTolerance',1e-9,'UseParallel',Parp);
%         'ObjectiveLimit',1e-3
        Y(i,:)=particleswarm(@FitnessFunction,8,LB,UB,opt2);
        toc
        save('Results_PSO','Y')
    
     elseif c==3
        popsize=input('Specify the population size: ');
        N=popsize;
        D=8;
        itmax=input('Specify the maximum number of iterations: ');
        disp(' ');
        disp('CHOICE OF THE D.E. PARAMETERS:');
        FR=input('Mutation ratio (F): ');
        CR=input('Crossover ratio (CR): ');
        run('DE_main');     %the "save" command is already inside the script (xbest)
        
        break
        
    elseif c==4
        SearchAgents_no=input('Specify the number of search agents: ');
        Max_iter=input('Specify the maximum number of iterations: ');
        dim=8;
        lb=zeros(1,dim);
        ub=ones(1,dim);       
        run('GWO_remix');   %the "save" command is already inside the script (Z)
        
        break
    else
        disp('Do a valid choice')
        break
    end
end

disp(' ')
disp('Optimization successfully termined')
        
